// ArithmeticClient.java

import java.io.*;
import java.net.*;

public class ArithmeticClient {

    public static void main(String[] args) {

        InetAddress addr = null;
        int port = -1;

        try {
            if (args.length == 2) {
                addr = InetAddress.getByName(args[0]);
                port = Integer.parseInt(args[1]);
            } else {
                System.out.println("Usage: java ArithmeticClient serverIP serverPort");
                System.exit(1);
            }
        } catch (UnknownHostException e) {
            System.out.println("Error while resolving server: ");
            e.printStackTrace();
            System.out.println("ArithmeticClient: terminating.");
            System.exit(2);
        }

        DatagramSocket socket = null;
        DatagramPacket packet = null;
        byte[] buf = new byte[512];

        // create datagram socket, set 30s timeout
        // and create datagram packet
        try {
            socket = new DatagramSocket();
            socket.setSoTimeout(30000);
            packet = new DatagramPacket(buf, buf.length, addr, port);
            System.out.println("\nArithmeticClient: started");
            System.out.println("Socket created: " + socket);

        } catch (SocketException e) {
            System.out.println("Error while creating socket: ");
            e.printStackTrace();
            System.out.println("ArithmeticClient: terminating.");
            System.exit(1);
        }

        BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));

        
        try {
        	ByteArrayOutputStream boStream = null;
        	DataOutputStream doStream = null;
        	byte[] data = null;
        	String response = null;
        	ByteArrayInputStream biStream = null;
        	DataInputStream diStream = null;
        	
        	String operation;
        	int op1 = 0;
        	int op2 = 0;
        	
        	boolean valid = false;

        	System.out.print("\n(^D(Unix)/^Z(Win)+enter to quit). Please input the operation type: (+ - * /): ");

        	while ( (operation = stdIn.readLine()) != null ) {

                valid = false;
                do {
                    try {
                        System.out.println("Pleas insert the first operand: ");
                        op1 = Integer.parseInt(stdIn.readLine());
                        valid = true;
                    } catch (NumberFormatException ex) {
                        continue;
                    }
                } while (!valid);

                valid = false;
                do {
                    try {
                        System.out.println("Pleas insert the second operand: ");
                        op2 = Integer.parseInt(stdIn.readLine());
                        valid = true;
                    } catch (NumberFormatException ex) {
                        continue;
                    }
                } while (!valid);

                boStream = new ByteArrayOutputStream();
                doStream = new DataOutputStream(boStream);
                doStream.writeUTF(operation);
                doStream.writeInt(op1);
                doStream.writeInt(op2);
                doStream.flush();
                data = boStream.toByteArray();
                packet.setData(data);
                socket.send(packet);

                packet.setData(new byte[512]);
                socket.receive(packet);

                biStream = new ByteArrayInputStream(packet.getData());
                diStream = new DataInputStream(biStream);
                response = diStream.readUTF();
                System.out.println("Response: " + response);
                if (response.equals("success")) {
                    int result = diStream.readInt();
                    System.out.println("Result: " + result);
                } else {
                    String errorDescr = diStream.readUTF();
                    System.out.println("Error description: " + errorDescr);
                }

                System.out.print("\n(^D(Unix)/^Z(Win)+enter to quit). Please input the operation type: (+ - * /): ");

            } // while

        } // catch all exceptions not managed in the main loop and terminate
        catch (Exception e) {
            e.printStackTrace();
        }

        System.out.println(
                "ArithmeticClient: terminating.");
        socket.close();
    }
}
